@echo off
rem (C) SSoft 2024 z-print@bk.ru
rem places each pages 2-3 over page 1 again and again 
IF NOT EXIST "%1" goto wrongfile
echo start >>times.txt
time /t >>times.txt 
rem имя исходного файла
set SRC=%1
rem положение каждой из страниц относительно выходного листа 
set shift_P1="-50mm 0mm"
set shift_P2="70mm 0mm"
set shift_P3="148mm 0mm"
rem размер листа для размещения страничек
set out_sheet_size="0mm 0mm 297mm 210mm"

rem папка для размещения временных файлов и шаблоны имен временных файлов 

set TMPFLD=%temp%\

set PGS=OutPages
set PG1=%TMPFLD%%PGS%1.pdf
set PG1SHIFTED=%TMPFLD%%PGS%1_1.pdf
set PG2=%TMPFLD%%PGS%2.pdf
set PG3=%TMPFLD%%PGS%3.pdf
set OUT=%SRC:~0,-4%_OUT.pdf

rem Определим количество страниц в исходном файле
rem тупо взял из сети, там какая-то заморочка
setlocal ENABLEDELAYEDEXPANSION
FOR /F "usebackq delims=" %%a IN (`cpdf -info %SRC% ^| find "Pages:"`) DO (set result=%%a)
rem отрежем слово pages: и используем остаток как число страниц (именно как число /a)
set /a pages = %result:~7%

if %pages% LSS 3 goto shortfile

rem создадим переменные со списками страниц для тех файлов - 1е, 2е и 3и страницы, в списках не должно ыть пробелов, требования cpdf
set /a LIST1=1
set /a LIST2=2 
set /a LIST3=3

for /L %%i in (1,3,%pages%) do set LIST1=!LIST1!,%%i
for /L %%i in (2,3,%pages%) do set LIST2=!LIST2!,%%i
for /L %%i in (3,3,%pages%) do set LIST3=!LIST3!,%%i

rem избавимся от дублирующих первых цифр и запятой
set LIST1=%LIST1:~2%
set LIST2=%LIST2:~2%
set LIST3=%LIST3:~2%

cpdf -mediabox  "0mm 0mm 297mm 210mm" "%SRC%" AND -cropbox "0mm 0mm 297mm 210mm" AND -shift %shift_P1% -range %LIST1% AND -shift %shift_P2% -range %LIST2% AND -shift %shift_P3% -range %LIST3% -o "%PG1SHIFTED%" AND -merge "%PG1SHIFTED%" -range %LIST1% -o "%PG1%" AND -merge "%PG1SHIFTED%" -range %LIST2% -o "%PG2%" AND -merge "%PG1SHIFTED%" -range %LIST3% -o "%PG3%" AND -combine-pages "%PG2%" "%PG1%" AND -combine-pages "%PG3%" "%PG1%" -o "%OUT%

del "%PG1%"
del "%PG2%"
del "%PG3%"
del "%PG1SHIFTED%"

echo stop >>times.txt
time /t >>times.txt 
exit /b 0

:wrongfile

echo places each pages 2-3 over page 1 again and again 
echo Usage: %0 pdfname.pdf

echo no such file %1
echo 
exit /b -1

:shortfile
echo file %1 contains less than 3 pages and cannot be processed
exit /b -2